VERSION 5.00
Begin VB.Form frmOClock 
   BorderStyle     =   0  'None
   ClientHeight    =   2730
   ClientLeft      =   -45
   ClientTop       =   -330
   ClientWidth     =   2745
   Icon            =   "frmOClock.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   Picture         =   "frmOClock.frx":0442
   ScaleHeight     =   2730
   ScaleWidth      =   2745
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   2160
      Top             =   0
   End
   Begin VB.PictureBox P1 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      DrawWidth       =   2
      FillColor       =   &H000000FF&
      FillStyle       =   0  'Solid
      ForeColor       =   &H80000008&
      Height          =   1245
      Left            =   720
      ScaleHeight     =   1245
      ScaleWidth      =   1245
      TabIndex        =   0
      Top             =   720
      Width           =   1245
      Begin VB.Label lblClose 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "X"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000C0&
         Height          =   195
         Left            =   960
         TabIndex        =   2
         ToolTipText     =   "Close"
         Top             =   0
         Width           =   135
      End
      Begin VB.Label Label1 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "ffrrrrrrrrrrrrr"
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000C0&
         Height          =   180
         Left            =   275
         TabIndex        =   1
         Top             =   840
         Width           =   735
      End
   End
End
Attribute VB_Name = "frmOClock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'===================================================
'Analog Clock
'--------------------------------------------------
'Creates a round(circle) shaped form
'and draws Hr, Min, Sec hands(lines)
'to resemble an analog clock
'--------------------------------------------------
'Author: Dipak Auddy
'E-mail: auddy@gawab.com
'Date: Mar 17,2005.
'--------------------------------------------------
'Reference:
'Larry Serflaten
'E-Mail: serflaten@usinternet.com
'shows how to draw pointed hands for the clock
'===================================================

'API to move windowless form
Private Const HTCAPTION           As Long = 2
Private Const WM_NCLBUTTONDOWN    As Long = &HA1
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
                                                                        ByVal wMsg As Long, _
                                                                        ByVal wParam As Long, _
                                                                        lParam As Any) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
'API to create windowless form
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, _
                                                    ByVal hRgn As Long, _
                                                    ByVal bRedraw As Boolean) As Long
Private Declare Function CreateEllipticRgn Lib "gdi32" (ByVal X1 As Long, _
                                                        ByVal Y1 As Long, _
                                                        ByVal X2 As Long, _
                                                        ByVal Y2 As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

'The length of Hr,Min,Sec hands...
Private Const hWidth              As Long = 500
Private Const mWidth              As Long = 700
Private Const sWidth              As Long = 800
'Globals to store canvas(Picture Object)'s
'center co-ord.
Private X                         As Single
Private Y                         As Single
Private PI2                       As Double

Private Sub Form_Load()

Dim RGN As Long

    ' PI / 2
    PI2 = Atn(1) * 2
    With P1
        .BackColor = vbWhite
        'Let's save the points...
        X = .Width / 2
        Y = .Height / 2
    End With 'P1
    Label1.Caption = "Dipak Auddy" & vbCrLf & "auddy@gawab.com"
    'Make a round windowless! form...
    RGN = CreateEllipticRgn(0, 0, 175, 175)
    Call SetWindowRgn(Me.hwnd, RGN, True)
    Call DeleteObject(RGN)

End Sub

Private Sub Form_MouseDown(Button As Integer, _
                           Shift As Integer, _
                           X As Single, _
                           Y As Single)

'Ah! we have to move the form...

    If Button = 1 Then
        ReleaseCapture
        SendMessage Me.hwnd, WM_NCLBUTTONDOWN, HTCAPTION, ByVal 0&
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Timer1.Enabled = False

End Sub

Private Sub Label1_MouseDown(Button As Integer, _
                             Shift As Integer, _
                             X As Single, _
                             Y As Single)

    Form_MouseDown Button, Shift, X, Y

End Sub

Private Sub lblClose_Click()

    Unload Me

End Sub

Private Sub P1_MouseDown(Button As Integer, _
                         Shift As Integer, _
                         X As Single, _
                         Y As Single)

    Form_MouseDown Button, Shift, X, Y

End Sub

Private Sub Timer1_Timer()

Dim Angle, PX, PY, OX, OY, WX, WY

    P1.Cls
    'Get Hr Angle...
    Angle = (180 - (Hour(Now) * 6) * 5 - (Minute(Now) * 6) / 12) * 3.1415 / 180
    'Hr. point
    PX = X + (hWidth * Sin(Angle))
    PY = Y + (hWidth * Cos(Angle))
    'Opposite side
    OX = X - (Sin(Angle) * 100)
    OY = Y - (Cos(Angle) * 100)
    'Hand width
    WX = Sin(Angle + PI2) * 90
    WY = Cos(Angle + PI2) * 90
    'Draw Hr. hand...
    P1.Line (OX, OY)-(PX, PY), vbYellow    ' From opposite side to pointer
    P1.Line -(OX + WX, OY + WY), vbBlue  ' To one opposite side
    P1.Line -(OX - WX, OY - WY), vbBlue  ' To other opposite side
    P1.Line -(PX, PY), vbBlue           ' Back to pointer
    P1.Circle (X, Y), 50, vbYellow
    'Get Min Angle...
    Angle = (180 - (Minute(Now) * 6)) * 3.1415 / 180
    'Min point
    PX = X + (mWidth * Sin(Angle))
    PY = Y + (mWidth * Cos(Angle))
    'Opposite side
    OX = X - (Sin(Angle) * 100)
    OY = Y - (Cos(Angle) * 100)
    'Hand width
    WX = Sin(Angle + PI2) * 90
    WY = Cos(Angle + PI2) * 90
    'Draw Min. hand...
    P1.Line (OX, OY)-(PX, PY), vbYellow    ' From opposite side to pointer
    P1.Line -(OX + WX, OY + WY), vbMagenta  ' To one opposite side
    P1.Line -(OX - WX, OY - WY), vbMagenta  ' To other opposite side
    P1.Line -(PX, PY), vbMagenta           ' Back to pointer
    P1.Circle (X, Y), 50, vbYellow
    'Get Sec Angle...
    Angle = (180 - (Second(Now) * 6)) * 3.1415 / 180
    'Draw Sec. hand...
    P1.Line (X, Y)-(X + (sWidth * Sin(Angle)), Y + (sWidth * Cos(Angle))), vbRed

End Sub

':)Code Fixer V2.2.0 (17/03/2005 6:16:35 PM) 35 + 119 = 154 Lines Thanks Ulli for inspiration and lots of code.

